<?php

/* ***************************************************************************************************************************
    mysql.bible.search.php: This program is a search utillity for the three Bible translations used in the Php MySQL Bible Search
    written in Php using MySQL. Copyright (C) 2011 by Jerry B Nettrouer II <j2@inpito.org>

    This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
    version 3 as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this program.
    If not, see <http://www.gnu.org/licenses/>.
 ***************************************************************************************************************************** */

/* server information function to pass to all the mysql connections*/
function server($hash)
{
	/* Type in your own unique hash to protect this information from being called from another page */
	if($hash == "Replace this with your own unque hash")
	{
		$server['hostname'] = "hostname";
		$server['username'] = "username";
		$server['password'] = "password";
	}
	else
	{	/* Type in fake values here as a hacker deterent */
		$server['hostname'] = "Bad Hostname";
		$server['username'] = "Bad Username";
		$server['password'] = "Bad Password";
	}
	return $server;
}

function phrase($phrase)
{
	$a = server("Replace this with your own unque hash");
	
	$data = "";

	$connect = mysql_connect($a['hostname'], $a['username'], $a['password']) or die("Could not connect");

	$db = mysql_select_db("Bible") or die("Database unreachable");

	$query = "SELECT * FROM bible WHERE kjv LIKE '%$phrase%' OR usa LIKE '%$phrase%' OR asv LIKE '%$phrase%'";

	$result = mysql_query($query) or die("Could not preform query");

	$count = 0;

	while($entry = mysql_fetch_row($result))
	{
		$data[$count++] = display($entry);
	}
	mysql_close($connect);
	
	return $data;
}

function verse($variable)
{
	$a = server("Replace this with your own unque hash");

	$connect = mysql_connect($a['hostname'], $a['username'], $a['password']) or die("Could not connect");

	$db = mysql_select_db("Bible");

	$data = "";

	$truck = explode(";", $variable);

	$num = 0;

	$count = 0;

	foreach ($truck as $car)
	{
		$place = reference($car);

		$count = count($place['verse']);

		for($b = 0; $b < $count; $b++)
		{
			$book = $place['book']; $chapter = $place['chapter']; $verse = $place['verse'][$b];
	
			$query = "SELECT * FROM bible WHERE book='$book' AND chapter='$chapter' AND verse='$verse'";
	
			$result = mysql_query($query) or die("Could not preform query");
	
			while($entry = mysql_fetch_row($result))
			{
				$data[$num++] = display($entry);
			}
		}
	}
	mysql_close($connect);
	return $data;
}

function reference($variable)
{
	$data = "";
	
	$BibleArray = array("Genesis", "Exodus", "Leviticus", "Numbers", "Deuteronomy", "Joshua", "Judges", "Ruth", "II Samuel", "I Samuel", "II Kings", "I Kings",
		"II Chronicles", "I Chronicles", "Ezra", "Nehemiah", "Esther", "Job", "Psalms", "Proverbs", "Ecclesiastes", "Song of Solomon", "Isaiah",
		"Jeremiah", "Lamentations", "Ezekiel", "Daniel", "Hosea", "Joel", "Amos", "Obadiah", "Jonah", "Micah", "Nahum", "Habakkuk", "Zephaniah",
		"Haggai", "Zechariah", "Malachi", "Matthew", "Mark", "Luke", "III John", "II John", "I John", "John", "Acts", "Romans", "II Corinthians",
		"I Corinthians", "Galatians", "Ephesians", "Philippians", "Colossians", "II Thessalonians", "I Thessalonians", "II Timothy", "I Timothy",
		"Titus", "Philemon", "Hebrews", "James", "II Peter", "I Peter", "Jude", "Revelation");

	for ($a = 0; $a <= count($BibleArray); $a++)
	{
		$pos = strpos($variable, $BibleArray[$a]);  /* string, test */

		if ($pos !== false)
		{
			$data['book'] = $BibleArray[$a];

			$size_of = 1 + strlen($BibleArray[$a]);

			# echo $size_of."<br>";

			$data['ref'] = substr_replace($variable,'', 0, $size_of);

			$chapter = explode(":", $data['ref']);

			$data['chapter'] = $chapter[0];

			$verses = explode(",", $chapter[1]);

			$count = 0;

			foreach($verses as $verse)
			{
				$dash = strpos($verse, "-");
				
				if ($dash !== false)
				{	$span = explode("-",$verse);

					$from = $span[0];
					$to = $span[1];

					while($from <= $to)
					{
						$data['verse'][$count++] = $from++;
					}
				}
				else
				{	$data['verse'][$count++] = $verse; }
			}
			$a = count($BibleArray);
		}
	}
	return $data;
}

function display($results)
{	
	$local = $results[1].' '.$results[2].':['.$results[3].']';
	$kjv = $results[4];
	$usa = $results[5];
	$asv = $results[6];

	$data = "<tr><td><fieldset><legend><b> KJV ".$local." </b></legend> ".$kjv."</fieldset></td>";
	$data .= "<td><fieldset><legend><b> ASV ".$local." </b></legend>".$asv."</fieldset></td>";
	$data .= "<td><fieldset><legend><b> USA ".$local." </b></legend>".$usa."</fieldset></td></tr>";

	return $data;
 }

function help()
{
    $data = "<fieldset>
        <legend><b> Help </b></legend>
	  <center>The MySQL Bible Search 1.0 - written by Jerry B Nettrouer II <<a href=\"mailto:j2@inpito.org\">j2@inpito.org</a>></center>
	  <p align=\"left\">This program is a search utillity for the Judeo-Christian Bible (a.k.a. The Scriptures). The program can perform both phrase and multiple reference based searches of Scripture. The search returns with three publicly useable translations, the King James Version, American Standard Version, and the Uniform Standard America (a modified World English Bible).</p>
	  <p align=\"left\"><b>Reference Search Books:</b><br>
		Genesis, Exodus, Leviticus, Numbers, Deuteronomy, Joshua, Judges, Ruth, I Samuel, II Samuel, I Kings, II Kings, I Chronicles, II Chronicles, Ezra, Nehemiah, Esther, Job, Psalms, Proverbs, Ecclesiastes, Song of Solomon, Isaiah, Jeremiah, Lamentations, Ezekiel, Daniel, Hosea, Joel, Amos, Obadiah, Jonah, Micah, Nahum, Habakkuk, Zephaniah, Haggai, Zechariah, Malachi, Matthew, Mark, Luke, John, Acts, Romans, I Corinthians, II Corinthians, Galatians, Ephesians, Philippians, Colossians, I Thessalonians, II Thessalonians, I Timothy, II Timothy, Titus, Philemon, Hebrews, James, I Peter, II Peter, I John, II John, III John, Jude, Revelation.</p>
	  <p align=\"left\"><b>Reference Search Expressions:</b><br>
		Provided your search is a reference search in the same chapter you can use the following control characters to select which verses you want displayed. You can use a comma to seprate one verse from another, and a dash to generate a list of verses, as well as use a semi-colon for multiple verse searches. If you go beyond the verses in a chapter it will only return to the end of the chapter.</p>
	<p align=\"left\"><b>Examples:</b><br>
		Search : I Am the Lord -> A simple phrase based search.<br>
		Search : Genesis 15:1 -> A simple reference based search.<br>
		Search : John 3:16,18 -> A reference based search that returns John 3:16 & John 3:18.<br>
		Search : Matthew 22:37-39 -> A reference based search that return Matthew 22:37 to 39.<br>
		Search : Genesis 15:1; John 3:16,18; Matthew 22:37-39 -> All three searches in reference search.<br>
	<p align=\"left\"><b>Todo:</b><br>
		Falt tolerence ... That means if it's used right it will work right, if it's used wrong it will brake.
		Send bugs to <<a href=\"mailto:j2@inpito.org\">j2@inpito.org</a>>.
	<p align=\"left\"><b>Download:</b><br>
		If you like this Php MySQL Bible Search program you can download it free of cost at the <a target=\"windows\" href=\"http://www.inpito.org/index.php\">I.N.P.I.T.O.</a> the program is <a target=\"windows\" href=\"http://www.gnu.org/licenses/gpl.html\">GNU GENERAL PUBLIC LICENSE Version 3</a>.</p>
	</fieldset>";

	return $data;
}

if(strlen ($_POST['search']) > 0 )
{
	switch($_POST['criteria'])
	{
		case "phrase" : $camp = phrase($_POST['search']); $found = count($camp); break;
	
		case "reference" : $camp = verse($_POST['search']); $found = count($camp); break;
	
		default : $found = 0; $camp = "Input Type Not Recognized";
	}

	foreach($camp as $entry)
	{
		$page .= $entry;
	}
}
else
{
	$page = help();
	$found = 0;
}

?>

<html>
<body>
<form method="post" action="mysql.bible.search.php">
<fieldset>
    <legend><b> MySQL Bible Search </b></legend>
	<table border="0" cellpadding="3" cellspacing="0" width="100%">
           <tr>
             <td width="2%" align="center">&nbsp;</td>
             <td width="96%" align="center">
		Search : <input type="text" name="search" size="30" /> 
		By : <input type="radio" name="criteria" value="phrase" checked /> Phrase | <input type="radio" name="criteria" value="reference" /> Reference &nbsp;
		<input type="submit" name="submit" value="Submit" /> &nbsp; <input type="reset" value="Reset" />
	     </td>
	     <td width="2%" align="center">&nbsp;</td>
</table>
</fieldset>
</form>

<table width="100%" cellspacing="3">
	<tr>
	    <td width="90%" align="left"><b>Search:</b> <?php echo $_POST['search']; ?></td>
	    <td width="10%" align="right"><?php echo $found; ?><b> Results</b></td>
	</tr>
</table>

<?php

/* Php MySQL Bible Search */
echo "<table width=\"100%\" cellspacing=\"3\">";
echo $page;
echo "</table>";

?>

</body>
</html>
